﻿Type=Activity
Version=2.71
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim MapPoint1X As Float
	Dim MapPoint1Y As Float
	Dim MapPoint2X As Float
	Dim MapPoint2Y As Float
	Dim MapPointsXDiff As Float
	Dim MapPointsYDiff As Float
	Dim MapPoint1Lng As Double
	Dim MapPoint1Lat As Double
	Dim MapPoint2Lng As Double
	Dim MapPoint2Lat As Double
	Dim MapPointsLngDiff As Double
	Dim MapPointsLatDiff As Double
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("calibrate")
	Activity.Title = Main.ProgName & " " & Main.ProgVersion & " " & "Calibrate Map"
End Sub

Sub Activity_Resume
	Activity.Title = Main.ProgName & " " & Main.ProgVersion & " " & "Calibrate"
	' User marks 2 points & inputs for each their latitude & longitude as numbers with 6 decimal places
	Dim Latitude1, Latitude2, Longitude1, Longitude2 As Double
	Dim Distance As Double
	Distance = CalcDistanceBetween2Points(Latitude1, Latitude2, Longitude1, Longitude2)
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub CalcDistanceBetween2Points(Lat1 As Double, Lat2 As Double, Lon1 As Double, Lon2 As Double) As Double
' Spherical Law of Cosines formula
' Distance = acos(sin(φ1).sin(φ2) + cos(φ1).cos(φ2).cos(Δλ)).R
' where	φ is latitude, λ is longitude, R is earth’s radius (mean radius = 6,371km),
'  	note that angles need to be in radians to pass to trig functions!
  Dim R As Int: R = 6371 'km
  Dim Lat1Rad : Lat1Rad = (cPI * Lat1) / 180
  Dim Lat2Rad : Lat2Rad = (cPI * Lat2) / 180
  Dim LonDiffRad As Double : LonDiffRad = (cPI * (Lon2-Lon1)) / 180
  Return(ACos((Sin(Lat1Rad)*Sin(Lat2Rad))+(Cos(Lat1Rad)*Cos(Lat2Rad)*Cos(LonDiffRad)))*R)
End Sub

Sub CalcMapScales
	' Calculates the map scales
	MapPointsXDiff = MapPoint2X - MapPoint1X
	MapPointsYDiff = MapPoint2Y - MapPoint1Y
	MapPointsLngDiff = MapPoint2Lng - MapPoint1Lng
	MapPointsLatDiff = MapPoint2Lat - MapPoint1Lat
	Main.MapScaleLng = MapPointsLngDiff / MapPointsXDiff 
	Main.MapScaleLat = MapPointsLatDiff / MapPointsYDiff
End Sub


