﻿Type=Activity
Version=2.71
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: True
#End Region

'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim pnlSetupGPS, pnlGPSPathUnits, pnlMapDefaultLocation, pnlGPSSetup, pnlMapSetup, pnlMapLine As Panel
	Dim pnlSetup As Panel
	
	Dim cbxGPSDispSpeed, cbxGPSDispBearing As CheckBox
	Dim cbxDrawGPSPath, cbxSaveGPSPath, cbxGPSDispSpeed, cbxGPSDispBearing As CheckBox
	Dim cbxShowGPSOnMap, cbxDrawGPSPath, cbxSaveGPSPath As CheckBox
		
	Dim edtMapDefaultLocationLng, edtMapDefaultLocationLat, edtGPSMinTime, edtGPSMinDistance As EditText
	
	Dim spnMapLineWidth, spnMapLineColor, spnMapLineOpacity As Spinner
	Dim spnAltitudeUnit, spnSpeedUnit, spnDistanceUnit As Spinner

	Dim scvSetup As ScrollView
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("setup")
End Sub

Sub Activity_Resume
	Activity.Title = Main.ProgName & " " & Main.ProgVersion & " " & "Maintain Setup Details"
	InitSetup
	UpdateSetup
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	Main.GPSMinTime = edtGPSMinTime.Text * 1000		' time in milliseconds
	Main.GPSMinDistance = edtGPSMinDistance.Text
	Main.MapDefaultLat = edtMapDefaultLocationLat.Text
	Main.MapDefaultLng = edtMapDefaultLocationLng.Text
End Sub

Sub InitSetup
	' Initializes the Spinners
	Dim i As Int
	
	spnMapLineWidth.Clear
	spnMapLineWidth.Add(1)
	spnMapLineWidth.Add(2)
	spnMapLineWidth.Add(3)
	spnMapLineWidth.Add(5)

	spnMapLineColor.Clear
	spnMapLineColor.Add("Red")
	spnMapLineColor.Add("Blue")
	spnMapLineColor.Add("Green")
	
	spnMapLineOpacity.Clear
	spnMapLineOpacity.Add(0.25)
	spnMapLineOpacity.Add(0.5)
	spnMapLineOpacity.Add(0.75)
	spnMapLineOpacity.Add(1)
	
	spnAltitudeUnit.Clear
	For i = 0 To Main.AltitudeUnitNumber - 1
		spnAltitudeUnit.Add(Main.AltitudeUnitText(i))
	Next

	spnSpeedUnit.Clear
	For i = 0 To Main.SpeedUnitNumber - 1
		spnSpeedUnit.Add(Main.SpeedUnitText(i))
	Next

	spnDistanceUnit.Clear
	For i = 0 To Main.DistanceUnitNumber - 1
		spnDistanceUnit.Add(Main.DistanceUnitText(i))
	Next
	
End Sub

Sub UpdateSetup
	edtGPSMinTime.Text = Main.GPSMinTime / 1000		' time in milliseconds but diplayed in seconds
	edtGPSMinDistance.Text = Main.GPSMinDistance
	
	cbxDrawGPSPath.Checked = Main.DrawGPSPath
	cbxSaveGPSPath.Checked = Main.SaveGPSPath

	spnMapLineColor.SelectedIndex = Main.MapLineColorIndex
	spnMapLineWidth.SelectedIndex = Main.MapLineWidthIndex
	spnMapLineOpacity.SelectedIndex = Main.MapLineOpacityIndex
	spnAltitudeUnit.SelectedIndex = Main.AltitudeUnitIndex
	spnSpeedUnit.SelectedIndex = Main.SpeedUnitIndex
	spnDistanceUnit.SelectedIndex = Main.DistanceUnitIndex
End Sub

Sub edtMapDefaultLocationLat_FocusChanged (HasFocus As Boolean)
	If HasFocus = True Then
		scvSetup.ScrollPosition = pnlMapDefaultLocation.Top
	End If
End Sub

Sub edtMapDefaultLocationLng_FocusChanged (HasFocus As Boolean)
	If HasFocus = True Then
		scvSetup.ScrollPosition = pnlMapDefaultLocation.Top
	End If
End Sub

Sub cbxDispMapMarkers_CheckedChange(Checked As Boolean)
	Main.DispMapMarkers = Checked
End Sub

Sub cbxDispMapPolyline_CheckedChange(Checked As Boolean)
	Main.DispMapPolyLine = Checked
End Sub

Sub cbxDrawGPSPath_CheckedChange(Checked As Boolean)
	Main.DrawGPSPath = Checked
End Sub

Sub cbxSaveGPSPath_CheckedChange(Checked As Boolean)
	Main.SaveGPSPath = Checked
End Sub

Sub cbxGPSDispSpeed_CheckedChange(Checked As Boolean)
	Main.GPSDispSpeed = Checked
End Sub

Sub cbxGPSDispBearing_CheckedChange(Checked As Boolean)
	Main.GPSDispBearing = Checked
End Sub

Sub spnAltitudeUnit_ItemClick (Position As Int, Value As Object)
	Main.AltitudeUnitIndex = Position
End Sub

Sub spnSpeedUnit_ItemClick (Position As Int, Value As Object)
	Main.SpeedUnitIndex = Position
End Sub

Sub spnDistanceUnit_ItemClick (Position As Int, Value As Object)
	Main.DistanceUnitIndex = Position
End Sub

Sub spnMapLineColor_ItemClick (Position As Int, Value As Object)
	Main.MapLineColorIndex = Position
	Select Main.MapLineColorIndex
	Case 0
		Main.MapLineColor = "ff0000"
	Case 1
		Main.MapLineColor = "0000ff"
	Case 2
		Main.MapLineColor = "00ff00"
	End Select
End Sub

Sub spnMapLineWidth_ItemClick (Position As Int, Value As Object)
	Main.MapLineWidthIndex = Position
	Main.MapLineWidth = Value
End Sub

Sub spnMapLineOpacity_ItemClick (Position As Int, Value As Object)
	Main.MapLineOpacityIndex = Position
	Main.MapLineOpacity = Value
End Sub

